VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsCondFormManager"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public wb As Workbook
Public ws As Worksheet

Dim irow As Long
Public c_tgt As Long
Public c_src As Long
Dim c_sht As Long
Dim c_op As Long
Dim c_val As Long
Dim c_res As Long


Dim nrow





Private Sub class_initialize()

    Set wb = ThisWorkbook
    Set ws = ThisWorkbook.Worksheets("InternalUseOnly_CondFormat")
    
    c_tgt = WorksheetFunction.Match("c_tgt", ws.Rows(1), 0)
    c_src = WorksheetFunction.Match("c_src", ws.Rows(1), 0)
    c_sht = WorksheetFunction.Match("Sheet", ws.Rows(1), 0)
    c_op = WorksheetFunction.Match("op", ws.Rows(1), 0)
    c_val = WorksheetFunction.Match("value", ws.Rows(1), 0)
    c_res = WorksheetFunction.Match("result", ws.Rows(1), 0)
    
    nrow = ws.UsedRange.Rows.Count
    irow = 1
    

End Sub

Public Sub clean(shname As String)
    ' wipes pre-existing conditional format
    Dim my_sh As Worksheet
    
    Set my_sh = wb.Worksheets(shname)
    With my_sh.Cells
        
        .FormatConditions.Delete
    End With
End Sub



Public Sub reverse_order(shname As String)
    ' reverse the order of rules (i want to define rules in cascading order, the bottom one wins)
    ' wipes pre-existing conditional format
    Dim my_sh As Worksheet
    Dim fc As FormatCondition
    Dim n_fc As Long, i As Long, j As Long
    Dim porder() As Long
    Dim k As Long
    
    
    Set my_sh = wb.Worksheets(shname)
    With my_sh.Cells
    
        
        n_fc = .FormatConditions.Count
        ReDim porder(1 To n_fc)
        
        ' find what's the current order is
        i = 0
        For Each fc In .FormatConditions
            i = i + 1
            porder(fc.Priority) = i
        Next
        
        'reverse the order
        ' the doc says:
        '    changing the priority for the specified conditional formatting rule may cause
        '    the priority value of the other rules on the worksheet to be shifted
        ' it may cause, but doesnt say how.  and actually it "should" cause.
        ' so i try something on my own
        
        ' method 1 , start from tail, put near the top
        ' this didnt do anything....
'        For i = 1 To n_fc
'            j = n_fc - i + 1
'            Set fc = .FormatConditions(porder(j))
'            fc.Priority = i
'            print_order my_sh
'
'        Next
        
        For i = 1 To n_fc
            ' find the tail of condtions
            k = 0
            For j = 2 To n_fc
                Set fc = .FormatConditions(j)
                If fc.Priority > k Then
                    k = fc.Priority
                End If
            Next
                
            ' decide where to put
            j = n_fc - i + 1
            
            Set fc = .FormatConditions(k)
            fc.Priority = i
            print_order my_sh
            
        Next
        
        
    End With
    '

End Sub

Public Sub bld(o)
    Dim r_tgt As Range, r_src As Range
    Dim op As String, val As Variant, sval As String, res As String
    
    Set r_tgt = o("tgt")
    Set r_src = o("src")
    op = o("op")
    val = o("val")
    If IsNumeric(val) Then
        sval = "1"
    Else
        sval = """" & val & """"
    End If

    res = o("res")
    With r_tgt
        .FormatConditions.Add Type:=xlExpression, Formula1:= _
        "=" & r_src.Address(rowabsolute:=False) & op & sval
        With .FormatConditions(.FormatConditions.Count)
            .StopIfTrue = False
            With .Interior
                .PatternColorIndex = xlAutomatic
                If res = "mandatory" Then
                    .ThemeColor = xlThemeColorAccent4
                    .TintAndShade = 0.799981688894314
                ElseIf res = "optional" Then
                    .ThemeColor = xlThemeColorDark1
                    .TintAndShade = -0.14996795556505
                ElseIf res = "disabled" Then
                    .ThemeColor = xlThemeColorLight1
                    .TintAndShade = 0
                Else
                    Err.Raise 1, Description:="unknwon res: " & res

                End If
            End With
        End With
    End With



End Sub


Public Property Get chunk() As Object 'Dictionary
    Dim irow0 As Long, n As Long, shname As String
    Dim tgt0 As Variant, tgt1 As Variant, src0 As Variant, op0 As Variant, val0 As Variant, res0 As Variant
    Dim nr_out As Long
    irow = irow + 1
    irow0 = irow
    n = 0
    shname = ws.Cells(irow, c_sht)
    tgt0 = ws.Cells(irow, c_tgt)
    src0 = ws.Cells(irow, c_src)
    op0 = ws.Cells(irow, c_op)
    val0 = ws.Cells(irow, c_val)
    res0 = ws.Cells(irow, c_res)
    Do While True
        irow = irow + 1
        n = n + 1
        If irow > nrow Then
            Set chunk = Nothing
            Exit Property
        End If
        If Application.WorksheetFunction.IsNA(ws.Cells(irow, c_tgt)) Or Application.WorksheetFunction.IsError(ws.Cells(irow, c_tgt)) Then
            Exit Do
        End If
    Loop
    Dim sh As Worksheet
    Set sh = wb.Worksheets(shname)
    nr_out = sh.UsedRange.Rows.Count()
    tgt1 = ws.Cells(irow - 1, c_tgt)
    Debug.Assert tgt1 - tgt0 + 1 = n
    
    Dim rn As Range
    Dim o As Object
    
    Set o = New Collection
    o.Add Range(sh.Cells(2, tgt0), sh.Cells(nr_out, tgt1)), "tgt"
    o.Add sh.Cells(2, src0), "src"
    o.Add op0, "op"
    o.Add val0, "val"
    o.Add res0, "res"
    o.Add shname, "sht"
    
    
    
    
    Set chunk = o
    
End Property


