Attribute VB_Name = "dataValidation"
Option Explicit
    
Sub set_validations()
    Dim wb As Workbook, ws0 As Worksheet, rn0 As Range, rn As Range
    Dim wsTgt As Worksheet, rnTgt As Range, rnSrc As Range
    Dim c As Long, fmla As String
    Dim nChoice As Long
    
    Set wb = ThisWorkbook
    Set ws0 = ThisWorkbook.Worksheets("InternalUseOnly_Validation")
    
    Set rn0 = ws0.Cells(2, 1)
    Set rn0 = Application.Range(rn0, rn0.End(xlDown))
    
    ' March over first column of "InternalUseOnly_Validation"
    For Each rn In rn0
    
        fmla = ""
        ' Look at column E
        Set rnSrc = rn.Offset(0, 4)
        If Not IsEmpty(rnSrc) Then
            If Left(rnSrc.Value, 1) = "=" Then
                fmla = rnSrc.Value
            End If
        End If
        
        If fmla = "" Then
    
            ' Look at column F
            ' note that valid values typically starts with column E (offset=4), but
            ' sometimes it starts with F for some reason
            ' so i am checking column F if i can skip row (no validation list specified)
            Set rnSrc = rn.Offset(0, 5)
            If IsEmpty(rnSrc) Then
                GoTo continue_for
            End If
            
            ' Count how many options are available in the list
            nChoice = 1
            Do
                nChoice = nChoice + 1
            Loop While Not IsEmpty(rnSrc.Offset(0, nChoice - 1))
            nChoice = nChoice - 1
            
            ' come up with reference to the validation data
            Set rnSrc = Application.Range(rnSrc.Offset(0, -1), rnSrc.Offset(0, nChoice - 1))
            fmla = "=" & rnSrc.Address(external:=True)
        End If
        
        
        ' grab the the sheet where validation rule is placed
        Set wsTgt = wb.Worksheets(rn.Value)
        
        If rn.Value = "Global_Simulation_Parameters" Then
            ' Global_Simulation_Parameters, key value pair at each row
            
            ' find target column by looking at row 1,
            c = -1
            On Error Resume Next
            c = Application.WorksheetFunction.Match(rn.Offset(0, 1).Value, wsTgt.Columns(1), 0)
            On Error GoTo 0
            If c <= 0 Then
                GoTo continue_for
            End If
            
            ' grab cells where the rule applies
            Set rnTgt = wsTgt.Cells(c, 2)
        
        Else
            ' Regular intake sheet, tabular format, apply condition to a column
            
            ' find target column by looking at row 1,
            c = -1
            On Error Resume Next
            c = Application.WorksheetFunction.Match(rn.Offset(0, 1).Value, wsTgt.Rows(1), 0)
            On Error GoTo 0
            If c <= 0 Then
                GoTo continue_for
            End If
            
            Debug.Print rn.Value, rn.Offset(0, 1).Value
            
            ' grab cells where the rule applies
            Set rnTgt = Application.Intersect(wsTgt.Columns(c), wsTgt.UsedRange)
            Set rnTgt = Application.Range(rnTgt(2, 1), rnTgt(rnTgt.Rows.Count, 1))
        End If
        
        
        
        
        ' set the rule
        With rnTgt.Validation
            .Delete
            .Add Type:=xlValidateList, AlertStyle:=xlValidAlertStop, _
            Operator:=xlBetween, Formula1:=fmla
        End With
        
        
        
continue_for:
    Next
    

End Sub
    


