# CAMS Emission Composition Tool

## Quickstart

### Windows

Install the miniconda version of python from [https://docs.conda.io/en/latest/miniconda.html](https://docs.conda.io/en/latest/miniconda.html).  A python version >= 3.7 is required.

Download the source code from [http://dept.ceer.utexas.edu/ceer/ect/tool/CAMS-MEET-1.1.3-ECT.zip](http://dept.ceer.utexas.edu/ceer/ect/tool/CAMS-MEET-1.1.3-ECT.zip).  Save it to "C:\Users\yourname", where `yourname` is your Windows user name.  Expand the zip archive in the directory.  You should see a directory "CAMS-MEET-1.1.3-ECT".

From the start menu, start Anaconda (64-bit) -> Anaconda Prompt (Miniconda 3).  This will start a command prompt window with python in the path.  

In this command prompt, type the following commands:

`cd CAMS-MEET-1.1.3-ECT/DES1`

`pip install -r ../requirements.txt`

Download database file, `thermodynamics_database_v2_20200303.db` from [https://dept.ceer.utexas.edu/ceer/ect/files/thermodynamics_database_v2_20200303.zip](https://utexas.box.com/s/y5lp1btwqqlyz5eovw1jwwhjs1785bax), and place it in `GTI-CAMS/DES1/input` directory.

Then run

`python LookupMain.py -f Thermodynamic_Tool_Examples.xlsm`. 

This should run the example case.

### Linux/Mac

In an interactive shell, type following commands:

`wget https://dept.ceer.utexas.edu/ceer/ect/tool/CAMS-MEET-1.1.3-ECT.zip`

`unzip CAMS-MEET-1.1.3-ECT.zip` 

`cd CAMS-MEET-1.1.3-ECT/DES1`

`pip install -r ../requirements.txt`

Download database file, `thermodynamics_database_v2_20200303.db` from [https://dept.ceer.utexas.edu/ceer/ect/files/thermodynamics_database_v2_20200303.zip](https://dept.ceer.utexas.edu/ceer/ect/files/thermodynamics_database_v2_20200303.zip), and place it in `DES1/input` directory.

Then run

`python LookupMain.py -f Thermodynamic_Tool_Examples.xlsm`. 

This should run the example case.

### Command Line Arguments
Append these additional arguments after the call to `LookupMain.py` to control the behavior of the MEET model.

| Argument | Description | Default | Type |
|----------|-------------|---------|------|
| -f | Specifies the input spreadsheet to be used for the simulation | Master_Equipment_List.xlsm | filename with .xlsm extension |
| -o | Overrides Output file directory specified in “Output Directory" in Global_Simulation_Parameters sheet | None | |
| -p | Number of processors for multiprocessing | 1 | Int |

### Validating model runs
Output files will be placed in the `GTI-CAMS/DES1/outputs` directory. Each simulation run will generate a timestamped folder with the simulation results. The timestamp will be of the format `YYMMDD_HHMMSS`.

Within the timestamped directory, there will be two files: `GC_fingerprint.json` and `GC_fingerprint.csv`.  First file would be used for further processing in MEET emission modeling.  Second file is to be imported into other software (e.g. Microsoft Excel) for review/use the estimated compoistions. 
